<?php
namespace Internetgalerie\Flipbook\Controller;

use Internetgalerie\Flipbook\Utility\FlipbookUtility;
use Psr\Http\Message\ResponseInterface;
use TYPO3\CMS\Extbase\Mvc\Controller\ActionController;
use TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer;

/**
 * FlipbookController
 */
class FlipbookController extends ActionController
{
    protected ?ContentObjectRenderer $contentObj;
    protected FlipbookUtility $flipbookUtility;

    /**
     * @param FlipbookUtility $flipbookUtility
     */
    public function __construct(FlipbookUtility $flipbookUtility)
    {
        $this->flipbookUtility = $flipbookUtility;
    }
    public function initializeAction()
    {
    }
    
    /**
     * create Flipbook
     */
    //public function createFlipbookAction(): ResponseInterface
    public function createFlipbookAction(): ResponseInterface
    {
        if ($this->settings['library'] == 'pdf-flipbook' || ($this->settings['library'] == '' && $this->settings['setup']['library'] == 'pdf-flipbook')) {
            $library = 'pdf-flipbook';
            $pageRange = '0';
            //$pageRange = '1-2';
        } else {
            $library = 'booklet';
            $pageRange = '';
        }
        
        $this->contentObj = $this->request->getAttribute('currentContentObject');

        $pageImages = $this->flipbookUtility->getPageImagesByContentObject($this->contentObj, $pageRange);
        $pdfFile = $this->flipbookUtility->getPdfFilesByContentObject($this->contentObj);
        
        
        $config = [];
        foreach ([ 'closed', 'covers', 'autoCenter', 'pageNumbers', 'manual', 'hoverClick', 'overlays', 'tabs', 'arrows', 'arrowsHide', 'hash', 'keyboard', 'auto', 'pageSelector', 'chapterSelector', 'shadows', 'hardCover', 'useHandCursor', 'buttonMode', 'sideFlip', 'hover', 'hovers', 'flipOnClick', 'convertNew', 'singleZoom'] as $name) {
            //echo($name . '='. $this->settings[$name]);
            $config[$name] = $this->settings['setup'][$name] ? 'true' : 'false';
        }

        
        if ($library  === 'pdf-flipbook') {
            $thumbFile = $pageImages[0];
            $title = 'Best Projects';
            $html = '';
            foreach ($pdfFile as $pdf) {
                $html .= '<div class="_df_thumb" id="df_manual_thumb" source="' . $pdf->getPublicUrl() . '" thumb="' . $thumbFile->getPublicUrl() . '">' . htmlspecialchars($title) .  '</div >';
            }
            $html .='     <script defer  src="/typo3conf/ext/flipbook/Resources/Public/pdf-flipbook/dflip/js/dflip.min.js" data-ignore="1"></script>';
            $html .= '	<link rel="stylesheet" type="text/css" media="all"  href="/typo3conf/ext/flipbook/Resources/Public/pdf-flipbook/dflip/css/dflip.min.css" crossorigin="anonymous" />
<link rel="stylesheet" type="text/css" media="all"  href="/typo3conf/ext/flipbook/Resources/Public/pdf-flipbook/dflip/css/themify-icons.min.css" crossorigin="anonymous" />';
            return $html;
        }
        $this->view->assign('pdfFile', $pdfFile);
        $this->view->assign('config', $config);
        $this->view->assign('files', $pageImages);
        //        return $this->htmlResponse();

        return $this->htmlResponse();
    }
}
